module DecFracTests where
import DecFrac; import Testing
main = dotests2 "DecFracTests $Revision: 1.1 $" tests_d tests_b
-- definitions for testing (and tests of fromRule), not for you to implement
fromList :: [Digit] -> DecFrac
fromList ds = fromRule (\n -> if n <= (toInteger (length ds))
                              then ds!!(fromInteger (n-1)) else 0)
rep :: [Digit] -> DecFrac  -- form repeated decimal
rep ds = fromRule (\n -> ds!!(fromInteger ((n-1) `mod` (toInteger (length ds)))))
seventh = (rep [1,4,2,8,5,7])
eighth = (fromList [1,2,5])
ninth = (fromRule (\n -> 1))
tenth = (fromList [1])
eleventh = (rep [0,9])
gt800 = gt 800  -- 800 digits of comparison version of gt
-- testcases themselves
tests_d :: [TestCase Digit]
tests_d = [eqTest (digit seventh 1) "==" 1
          ,eqTest (digit seventh 2) "==" 4
          ,eqTest (digit seventh 3) "==" 2
          ,eqTest (digit seventh 8) "==" 4
          ,eqTest (digit seventh 601) "==" 1
          ,eqTest (digit eighth 1) "==" 1
          ,eqTest (digit eighth 2) "==" 2
          ,eqTest (digit eighth 3) "==" 5
          ,eqTest (digit eighth 4) "==" 0
          ,eqTest (digit eighth 99999999211345) "==" 0
          ,eqTest (digit ninth 9999999) "==" 1
          ,eqTest (digit tenth 1) "==" 1
          ,eqTest (digit tenth 2) "==" 0
          ,eqTest (digit tenth 3) "==" 0
          ,eqTest (digit tenth 44449921) "==" 0
          ,eqTest (digit eleventh 1) "==" 0
          ,eqTest (digit eleventh 2) "==" 9
          ,eqTest (digit eleventh 3) "==" 0
          ,eqTest (digit eleventh 6) "==" 9      ]
tests_b :: [TestCase Bool]
tests_b = [assertTrue (seventh `gt800` eighth)
          ,assertTrue (eighth `gt800` ninth)
          ,assertTrue (ninth `gt800` tenth)
          ,assertTrue (tenth `gt800` eleventh)
          ,assertFalse (eleventh `gt800` tenth)
          ,assertFalse (tenth `gt800` tenth)
          ,assertFalse (eighth `gt800` eighth)    ]
